#!/usr/bin/perl
use strict;
use warnings;
use Cwd;
  use Math::Trig ':radial';
use Math::Trig ':pi';

#En entrée, le script attend le nom du fichier xyz, un angle phi qui correspond à l'angle de rotation autour de l'axe z et un angle theta qui correspond à la rotation autour de y

#si Phi vaut 90 degré, la molécule sera tournée de 90 degrés dans le plan xy

#si theta vaut 0 degré, on aura une impression de perspective cavalière frontale
#si theta vaut 90 degrés, on aura une vue selon l'axe Oz initial
#si theta vaut -11.3, on aura une vue selon l'axe Ox initial.


#ouverture des fichiers d'entrée pour le singulet et le triplet
	open(my $input_s,  "<",  "$ARGV[0]")  or die "Can't open input: $!";
	open(my $out, ">",  "$ARGV[0].tex") or die "Can't open output.txt: $!";
my $num_ligne=0;
my @tableau_reor = ();
my %tableau_atomes = ();
my $nb_atomes=1;
my $current_working_directory = getcwd();
my $i;my $x;my $y;my $z;
my $l_x;my $l_y;my $l_z;
my $j;


$tableau_atomes{"H"}{"radius"}=0.1;$tableau_atomes{"H"}{"color"}="white";
$tableau_atomes{"He"}{"radius"}=0.05;$tableau_atomes{"He"}{"color"}="";

$tableau_atomes{"Li"}{"radius"}=0.315;$tableau_atomes{"Li"}{"color"}="Li";
$tableau_atomes{"Be"}{"radius"}=0.211;$tableau_atomes{"Be"}{"color"}="";
$tableau_atomes{"B"}{"radius"}=0.164;$tableau_atomes{"B"}{"color"}="B";
$tableau_atomes{"C"}{"radius"}=0.15;$tableau_atomes{"C"}{"color"}="gray";
$tableau_atomes{"N"}{"radius"}=0.17;$tableau_atomes{"N"}{"color"}="blue";
$tableau_atomes{"O"}{"radius"}=0.091;$tableau_atomes{"O"}{"color"}="red";
$tableau_atomes{"F"}{"radius"}=0.079;$tableau_atomes{"F"}{"color"}="F";
$tableau_atomes{"Ne"}{"radius"}=0.072;$tableau_atomes{"Ne"}{"color"}="";

$tableau_atomes{"Na"}{"radius"}=0.358;$tableau_atomes{"Na"}{"color"}="Na";
$tableau_atomes{"Mg"}{"radius"}=0.274;$tableau_atomes{"Mg"}{"color"}="Mg";
$tableau_atomes{"Al"}{"radius"}=0.223;$tableau_atomes{"Al"}{"color"}="Al";
$tableau_atomes{"Si"}{"radius"}=0.209;$tableau_atomes{"Si"}{"color"}="Si";
$tableau_atomes{"P"}{"radius"}=0.185;$tableau_atomes{"P"}{"color"}="orange";
$tableau_atomes{"S"}{"radius"}=0.27;$tableau_atomes{"S"}{"color"}="yellow";
$tableau_atomes{"Cl"}{"radius"}=0.28;$tableau_atomes{"Cl"}{"color"}="green";
$tableau_atomes{"Ar"}{"radius"}=0.134;$tableau_atomes{"Ar"}{"color"}="";

$tableau_atomes{"K"}{"radius"}=0.1;$tableau_atomes{"K"}{"color"}="K";
$tableau_atomes{"Ca"}{"radius"}=0.1;$tableau_atomes{"Ca"}{"color"}="Ca";
$tableau_atomes{"Sc"}{"radius"}=0.1;$tableau_atomes{"Sc"}{"color"}="Sc";
$tableau_atomes{"Ti"}{"radius"}=0.1;$tableau_atomes{"Ti"}{"color"}="Ti";
$tableau_atomes{"V"}{"radius"}=0.1;$tableau_atomes{"V"}{"color"}="V";
$tableau_atomes{"Cr"}{"radius"}=0.27 ;$tableau_atomes{"Cr"}{"color"}="Cr";
$tableau_atomes{"Mn"}{"radius"}=0.1;$tableau_atomes{"Mn"}{"color"}="Mn";
$tableau_atomes{"Fe"}{"radius"}=0.3;$tableau_atomes{"Fe"}{"color"}="Fe";
$tableau_atomes{"Co"}{"radius"}=0.1;$tableau_atomes{"Co"}{"color"}="Co";
$tableau_atomes{"Ni"}{"radius"}=0.1;$tableau_atomes{"Ni"}{"color"}="Ni";
$tableau_atomes{"Cu"}{"radius"}=0.1;$tableau_atomes{"Cu"}{"color"}="Cu";
$tableau_atomes{"Zn"}{"radius"}=0.1;$tableau_atomes{"Zn"}{"color"}="Zn";
$tableau_atomes{"Ga"}{"radius"}=0.1;$tableau_atomes{"Ga"}{"color"}="";
$tableau_atomes{"Ge"}{"radius"}=0.1;$tableau_atomes{"Ge"}{"color"}="Ge";
$tableau_atomes{"As"}{"radius"}=0.1;$tableau_atomes{"As"}{"color"}="As";
$tableau_atomes{"Se"}{"radius"}=0.30;$tableau_atomes{"Se"}{"color"}="Se";
$tableau_atomes{"Br"}{"radius"}=0.1;$tableau_atomes{"Br"}{"color"}="Br";
$tableau_atomes{"Kr"}{"radius"}=0.1;$tableau_atomes{"Kr"}{"color"}="";

$tableau_atomes{"Rb"}{"radius"}=0.1;$tableau_atomes{"Rb"}{"color"}="";
$tableau_atomes{"Sr"}{"radius"}=0.1;$tableau_atomes{"Sr"}{"color"}="";
$tableau_atomes{"Y"}{"radius"}=0.1;$tableau_atomes{"Y"}{"color"}="";
$tableau_atomes{"Zr"}{"radius"}=0.1;$tableau_atomes{"Zr"}{"color"}="";
$tableau_atomes{"Nb"}{"radius"}=0.1;$tableau_atomes{"Nb"}{"color"}="";
$tableau_atomes{"Mo"}{"radius"}=0.1;$tableau_atomes{"Mo"}{"color"}="Mo";
$tableau_atomes{"Tc"}{"radius"}=0.1;$tableau_atomes{"Tc"}{"color"}="";
$tableau_atomes{"Ru"}{"radius"}=0.1;$tableau_atomes{"Ru"}{"color"}="Ru";
$tableau_atomes{"Rh"}{"radius"}=0.1;$tableau_atomes{"Rh"}{"color"}="Rh";
$tableau_atomes{"Pd"}{"radius"}=0.1;$tableau_atomes{"Pd"}{"color"}="Pd";
$tableau_atomes{"Ag"}{"radius"}=0.1;$tableau_atomes{"Ag"}{"color"}="Ag";
$tableau_atomes{"Cd"}{"radius"}=0.1;$tableau_atomes{"Cd"}{"color"}="Cd";
$tableau_atomes{"In"}{"radius"}=0.1;$tableau_atomes{"In"}{"color"}="";
$tableau_atomes{"Sn"}{"radius"}=0.1;$tableau_atomes{"Sn"}{"color"}="Sn";
$tableau_atomes{"Sb"}{"radius"}=0.1;$tableau_atomes{"Sb"}{"color"}="";
$tableau_atomes{"Te"}{"radius"}=0.1;$tableau_atomes{"Te"}{"color"}="Te";
$tableau_atomes{"I"}{"radius"}=0.1;$tableau_atomes{"I"}{"color"}="I";
$tableau_atomes{"Xe"}{"radius"}=0.1;$tableau_atomes{"Xe"}{"color"}="";

$tableau_atomes{"Cs"}{"radius"}=0.1;$tableau_atomes{"Cs"}{"color"}="Cs";
$tableau_atomes{"Ba"}{"radius"}=0.1;$tableau_atomes{"Ba"}{"color"}="Ba";
$tableau_atomes{"Lu"}{"radius"}=0.1;$tableau_atomes{"Lu"}{"color"}="";
$tableau_atomes{"Hf"}{"radius"}=0.1;$tableau_atomes{"Hf"}{"color"}="";
$tableau_atomes{"Ta"}{"radius"}=0.1;$tableau_atomes{"Ta"}{"color"}="";
$tableau_atomes{"W"}{"radius"}=0.1;$tableau_atomes{"W"}{"color"}="W";
$tableau_atomes{"Re"}{"radius"}=0.1;$tableau_atomes{"Re"}{"color"}="Re";
$tableau_atomes{"Os"}{"radius"}=0.1;$tableau_atomes{"Os"}{"color"}="Os";
$tableau_atomes{"Ir"}{"radius"}=0.1;$tableau_atomes{"Ir"}{"color"}="Ir";
$tableau_atomes{"Pt"}{"radius"}=0.1;$tableau_atomes{"Pt"}{"color"}="Pt";
$tableau_atomes{"Au"}{"radius"}=0.1;$tableau_atomes{"Au"}{"color"}="Au";
$tableau_atomes{"Hg"}{"radius"}=0.1;$tableau_atomes{"Hg"}{"color"}="Hg";
$tableau_atomes{"Tl"}{"radius"}=0.1;$tableau_atomes{"Tl"}{"color"}="";
$tableau_atomes{"Pb"}{"radius"}=0.1;$tableau_atomes{"Pb"}{"color"}="Pb";
$tableau_atomes{"Bi"}{"radius"}=0.1;$tableau_atomes{"Bi"}{"color"}="";
$tableau_atomes{"Po"}{"radius"}=0.1;$tableau_atomes{"Po"}{"color"}="";
$tableau_atomes{"At"}{"radius"}=0.1;$tableau_atomes{"At"}{"color"}="";
$tableau_atomes{"Rn"}{"radius"}=0.1;$tableau_atomes{"Rn"}{"color"}="";

$tableau_atomes{"Fr"}{"radius"}=0.1;$tableau_atomes{"Fr"}{"color"}="";
$tableau_atomes{"Ra"}{"radius"}=0.1;$tableau_atomes{"Ra"}{"color"}="";
$tableau_atomes{"Lr"}{"radius"}=0.1;$tableau_atomes{"Lr"}{"color"}="";
$tableau_atomes{"Rf"}{"radius"}=0.1;$tableau_atomes{"Rf"}{"color"}="";
$tableau_atomes{"Db"}{"radius"}=0.1;$tableau_atomes{"Db"}{"color"}="";
$tableau_atomes{"Sg"}{"radius"}=0.1;$tableau_atomes{"Sg"}{"color"}="";
$tableau_atomes{"Bh"}{"radius"}=0.1;$tableau_atomes{"Bh"}{"color"}="";
$tableau_atomes{"Hs"}{"radius"}=0.1;$tableau_atomes{"Hs"}{"color"}="";
$tableau_atomes{"Mt"}{"radius"}=0.1;$tableau_atomes{"Mt"}{"color"}="";
$tableau_atomes{"Ds"}{"radius"}=0.1;$tableau_atomes{"Ds"}{"color"}="";
$tableau_atomes{"Rg"}{"radius"}=0.1;$tableau_atomes{"Rg"}{"color"}="";

$tableau_atomes{"La"}{"radius"}=0.1;$tableau_atomes{"La"}{"color"}="";
$tableau_atomes{"Ce"}{"radius"}=0.1;$tableau_atomes{"Ce"}{"color"}="";
$tableau_atomes{"Pr"}{"radius"}=0.1;$tableau_atomes{"Pr"}{"color"}="";
$tableau_atomes{"Nd"}{"radius"}=0.1;$tableau_atomes{"Nd"}{"color"}="";
$tableau_atomes{"Pm"}{"radius"}=0.1;$tableau_atomes{"Pm"}{"color"}="";
$tableau_atomes{"Sm"}{"radius"}=0.1;$tableau_atomes{"Sm"}{"color"}="";
$tableau_atomes{"Eu"}{"radius"}=0.1;$tableau_atomes{"Eu"}{"color"}="Eu";
$tableau_atomes{"Gd"}{"radius"}=0.1;$tableau_atomes{"Gd"}{"color"}="Gd";
$tableau_atomes{"Tb"}{"radius"}=0.1;$tableau_atomes{"Tb"}{"color"}="";
$tableau_atomes{"Dy"}{"radius"}=0.1;$tableau_atomes{"Dy"}{"color"}="";
$tableau_atomes{"Ho"}{"radius"}=0.1;$tableau_atomes{"Ho"}{"color"}="";
$tableau_atomes{"Er"}{"radius"}=0.1;$tableau_atomes{"Er"}{"color"}="";
$tableau_atomes{"Tm"}{"radius"}=0.1;$tableau_atomes{"Tm"}{"color"}="";
$tableau_atomes{"Yb"}{"radius"}=0.1;$tableau_atomes{"Yb"}{"color"}="";

$tableau_atomes{"Ac"}{"radius"}=0.1;$tableau_atomes{"Ac"}{"color"}="";
$tableau_atomes{"Th"}{"radius"}=0.1;$tableau_atomes{"Th"}{"color"}="";
$tableau_atomes{"Pa"}{"radius"}=0.1;$tableau_atomes{"Pa"}{"color"}="";
$tableau_atomes{"U"}{"radius"}=0.1;$tableau_atomes{"U"}{"color"}="U";
$tableau_atomes{"Np"}{"radius"}=0.1;$tableau_atomes{"Np"}{"color"}="";
$tableau_atomes{"Pu"}{"radius"}=0.1;$tableau_atomes{"Pu"}{"color"}="";
$tableau_atomes{"Am"}{"radius"}=0.1;$tableau_atomes{"Am"}{"color"}="";
$tableau_atomes{"Cm"}{"radius"}=0.1;$tableau_atomes{"Cm"}{"color"}="";
$tableau_atomes{"Bk"}{"radius"}=0.1;$tableau_atomes{"Bk"}{"color"}="";
$tableau_atomes{"Cf"}{"radius"}=0.1;$tableau_atomes{"Cf"}{"color"}="";
$tableau_atomes{"Es"}{"radius"}=0.1;$tableau_atomes{"Es"}{"color"}="";
$tableau_atomes{"Fm"}{"radius"}=0.1;$tableau_atomes{"Fm"}{"color"}="";
$tableau_atomes{"Md"}{"radius"}=0.1;$tableau_atomes{"Md"}{"color"}="";
$tableau_atomes{"No"}{"radius"}=0.1;$tableau_atomes{"No"}{"color"}="";




##################################################################################
my $k;
#Multiplication de matrice
sub matrix_multiply {
    my ($r_mat1,$r_mat2)=@_;
    my ($r_product);
    my ($r1,$c1)=matrix_count_rows_cols($r_mat1);
    my ($r2,$c2)=matrix_count_rows_cols($r_mat2);
    
    die "matrix 1 has $c1 columns and matrix 2 has $r2 rows>" 
        . " Cannot multiply\n" unless ($c1==$r2);
    for (my $i=0;$i<$r1;$i++) {
        for (my $j=0;$j<$c2;$j++) {
            my $sum=0;
            for (my $k=0;$k<$c1;$k++) {
                $sum+=$r_mat1->[$i][$k]*$r_mat2->[$k][$j];
            }
            $r_product->[$i][$j]=$sum;
        }
    }
    $r_product;
}


sub matrix_add {
    my ($r_mat1,$r_mat2)=@_;
    my ($r_add);
    my ($r1,$c1)=matrix_count_rows_cols($r_mat1);
    my ($r2,$c2)=matrix_count_rows_cols($r_mat2);
    
    die "matrix 1 has $c1 columns and matrix 2 has $r2 rows>" 
        . " Cannot multiply\n" unless ($c1==$c2 && $r1==$r2);
   for (my $i=0;$i<$r1;$i++) 
	{
	   for (my $j=0;$j<$c1;$j++) 
		{
			$r_add->[$i][$j]=$r_mat1->[$i][$j]+$r_mat2->[$i][$j];
   	}
   }
   $r_add;
}


sub matrix_multiply_scalar {
    my ($r_mat1,$scalar)=@_;
    my ($r_prod);
    my ($r1,$c1)=matrix_count_rows_cols($r_mat1);
   for (my $i=0;$i<$r1;$i++) 
	{
	   for (my $j=0;$j<$c1;$j++) 
		{
			$r_prod->[$i][$j]=$r_mat1->[$i][$j]*$scalar;
   	}
   }
   $r_prod;
}



sub matrix_transpose {
	my ($r_mat1)=@_;
	my ($r_transpo);
	my ($r1,$c1)=matrix_count_rows_cols($r_mat1);
	for (my $i=0;$i<$r1;$i++) 
	{
		for (my $k=0;$k<$c1;$k++) 
			{
				$r_transpo->[$i][$k]=$r_mat1->[$k][$i];
			}
	}
	$r_transpo;
}

#Calcul des dimensions de la matrice
sub matrix_count_rows_cols { 
    my ($r_mat)=@_;
    my $num_rows=@$r_mat;
    my $num_cols=@{$r_mat->[0]};
    ($num_rows,$num_cols);
}


##################################################################################


while (<$input_s>) 
{ 
#Si la ligne est une ligne de coordonnées, on la lit, puis on regarde si il y a déjà un atome de ce type dans le tableau, si oui, on le rajoute à la suite des atomes de même type, sinon, on crée une nouvelle ligne pour le nouveau type d'atomes
if($num_ligne>1 && /\s*([A-Za-z]*)\s*([\d\-\.\+]*)\s*([\d\-\.\+]*)\s*([\d\-\.\+]*)/)
	{
# $2 ancien $x $3 ancien y $4 ancien z
		$x=$2;
		$y=$3;
		$z=$4;
		$tableau_reor[$nb_atomes][0]=$x;
		$tableau_reor[$nb_atomes][1]=$y;
		$tableau_reor[$nb_atomes][2]=$z;
		$tableau_reor[$nb_atomes][3]=$1;
		$tableau_reor[$nb_atomes][4]=$nb_atomes;
		$nb_atomes++;
	}
	$num_ligne++;
}
$nb_atomes--;


my $phi=$ARGV[1]*pi/180;
#On créee la matrice de rotation d'angle -phi autour de z
my @matrice_rota;
$matrice_rota[0][0]=cos($phi)	;$matrice_rota[0][1]=-sin($phi)	;$matrice_rota[0][2]=0;
$matrice_rota[1][0]=sin($phi)	;$matrice_rota[1][1]=cos($phi)	;$matrice_rota[1][2]=0;
$matrice_rota[2][0]=0		;$matrice_rota[2][1]=0		;$matrice_rota[2][2]=1;


my @vecteur;
for($i=1;$i<=$nb_atomes;$i++)
{
	#création du vecteur correspondant au coordonnées de l'atome
	$vecteur[0][0]=$tableau_reor[$i][0];
	$vecteur[1][0]=$tableau_reor[$i][1];
	$vecteur[2][0]=$tableau_reor[$i][2];
	my $vecteur_rota=matrix_multiply(\@matrice_rota,\@vecteur);
	
	$tableau_reor[$i][0]=sprintf("%.4f", $vecteur_rota->[0][0]);
	$tableau_reor[$i][1]=sprintf("%.4f", $vecteur_rota->[1][0]);
	$tableau_reor[$i][2]=sprintf("%.4f", $vecteur_rota->[2][0]);
}
my $theta;
$theta=$ARGV[2]*pi/180;
my @matrice_rota_t;
$matrice_rota_t[0][0]=cos($theta)	;$matrice_rota_t[0][1]=0	;$matrice_rota_t[0][2]=sin($theta);
$matrice_rota_t[1][0]=0			;$matrice_rota_t[1][1]=1	;$matrice_rota_t[1][2]=0;
$matrice_rota_t[2][0]=-sin($theta)	;$matrice_rota_t[2][1]=0	;$matrice_rota_t[2][2]=cos($theta);

for($i=1;$i<=$nb_atomes;$i++)
{
	#création du vecteur correspondant au coordonnées de l'atome
	$vecteur[0][0]=$tableau_reor[$i][0];
	$vecteur[1][0]=$tableau_reor[$i][1];
	$vecteur[2][0]=$tableau_reor[$i][2];
	my $vecteur_rota=matrix_multiply(\@matrice_rota_t,\@vecteur);
	
	$tableau_reor[$i][0]=sprintf("%.4f", $vecteur_rota->[0][0]);
	$tableau_reor[$i][1]=sprintf("%.4f", $vecteur_rota->[1][0]);
	$tableau_reor[$i][2]=sprintf("%.4f", $vecteur_rota->[2][0]);
}

#rotaton autour de x
$theta=$ARGV[3]*pi/180;

$matrice_rota_t[0][0]=1		;$matrice_rota_t[0][1]=0		;$matrice_rota_t[0][2]=0;
$matrice_rota_t[1][0]=0		;$matrice_rota_t[1][1]=cos($theta)	;$matrice_rota_t[1][2]=sin($theta);
$matrice_rota_t[2][0]=0		;$matrice_rota_t[2][1]=-sin($theta)	;$matrice_rota_t[2][2]=cos($theta);

for($i=1;$i<=$nb_atomes;$i++)
{
	#création du vecteur correspondant au coordonnées de l'atome
	$vecteur[0][0]=$tableau_reor[$i][0];
	$vecteur[1][0]=$tableau_reor[$i][1];
	$vecteur[2][0]=$tableau_reor[$i][2];
	my $vecteur_rota=matrix_multiply(\@matrice_rota_t,\@vecteur);
	
	$tableau_reor[$i][0]=sprintf("%.4f", $vecteur_rota->[0][0]);
	$tableau_reor[$i][1]=sprintf("%.4f", $vecteur_rota->[1][0]);
	$tableau_reor[$i][2]=sprintf("%.4f", $vecteur_rota->[2][0]);
}


























#############################
#SORTIE TIKZ
#############################

print $out "\\documentclass{article}\n\\usepackage{tikz,pgffor}\n\\usetikzlibrary{shadows}\n
%\\usepackage[paperwidth=5cm,paperheight=5cm,left=0cm,top=0cm]{geometry}
\\begin{document}\n

\\tikzset{math3d/.style={z= {(-0cm,-0.2cm)}, y={(0cm,1cm)},x={(1cm,0cm)}}}\n

\\definecolor{Li}{RGB}{204,128,255}
\\definecolor{B}{RGB}{255,181,181}
\\definecolor{F}{RGB}{144,224,80}
\\definecolor{Na}{RGB}{171,92,242}
\\definecolor{Mg}{RGB}{138,255,0}
\\definecolor{Al}{RGB}{191,166,166}
\\definecolor{Si}{RGB}{240,200,160}
\\definecolor{K}{RGB}{143,64,212}
\\definecolor{Ca}{RGB}{61,255,0}
\\definecolor{Sc}{RGB}{230,230,230}
\\definecolor{Ti}{RGB}{191,194,199}
\\definecolor{V}{RGB}{166,166,171}
\\definecolor{Cr}{RGB}{138,153,199}
\\definecolor{Mn}{RGB}{156,122,199}
\\definecolor{Fe}{RGB}{224,102,51}
\\definecolor{Co}{RGB}{240,144,160}
\\definecolor{Ni}{RGB}{80,208,80}
\\definecolor{Cu}{RGB}{200,128,51}
\\definecolor{Zn}{RGB}{125,128,176}
\\definecolor{Ge}{RGB}{102,143,143}
\\definecolor{As}{RGB}{189,128,227}
\\definecolor{Se}{RGB}{255,161,0}
\\definecolor{Br}{RGB}{166,41,41}
\\definecolor{Mo}{RGB}{84,181,181}
\\definecolor{Ru}{RGB}{36,143,143}
\\definecolor{Rh}{RGB}{10,125,140}
\\definecolor{Pd}{RGB}{0,105,133}
\\definecolor{Ag}{RGB}{192,192,192}
\\definecolor{Cd}{RGB}{255,217,143}
\\definecolor{Sn}{RGB}{102,128,128}
\\definecolor{Te}{RGB}{212,122,0}
\\definecolor{I}{RGB}{148,0,148}
\\definecolor{Cs}{RGB}{87,23,143}
\\definecolor{Ba}{RGB}{0,201,0}
\\definecolor{Ce}{RGB}{255,255,199}
\\definecolor{Eu}{RGB}{97,255,199}
\\definecolor{Gd}{RGB}{69,255,199}
\\definecolor{W}{RGB}{33,148,214}
\\definecolor{Re}{RGB}{38,125,171}
\\definecolor{Os}{RGB}{38,102,150}
\\definecolor{Ir}{RGB}{23,84,135}
\\definecolor{Pt}{RGB}{208,208,224}
\\definecolor{Au}{RGB}{255,209,35}
\\definecolor{Hg}{RGB}{184,184,208}
\\definecolor{Pb}{RGB}{87,89,97}
\\definecolor{U}{RGB}{0,143,255}


\\centering\n\\begin{tikzpicture}[math3d]\n\\begin{scope}[rotate around = {-0:(0,0,0)}]\n";
print $out "  \\tikzset{liaison/.style={line width=2pt,color=black,line cap=round}}\n";
print $out "  \\tikzset{liaison2/.style={line width=1pt,color=violet,line cap=round,loosely dashed}}\n";
print $out "	%\\draw[thick,->] (0,0,0) -- (1,0,0) node[anchor=north east]{y};\\draw[thick,->] (0,0,0) -- (0,1,0) node[anchor=north west]{z};\\draw[thick,->] (0,0,0) -- (0,0,1) node[anchor=south]{x};\n";



#jaune 255 253 154
#bleu 203 255 244



#On réorganise le tableau en fonction de la profondeur
$tableau_reor[0][0]=0.;
for($i=1;$i<=$nb_atomes;$i++)
{
	$j=$i;
	while($tableau_reor[$j][0]>$tableau_reor[$j-1][0] && $j>1)
	{
		#sauvegarde des donnes
		$tableau_reor[5000]=$tableau_reor[$j];
		$tableau_reor[$j]=$tableau_reor[$j-1];
		$tableau_reor[$j-1]=$tableau_reor[5000];
		$j=$j-1;
	}
}

print $out "%correspondance atome en sortie, atome en entrée\n";
#affichage du tableau de correspondance si nécessaire
for($i=1;$i<=$nb_atomes;$i++)
{
	print $out "%$tableau_reor[$i][3]$i\tcorrespond à\t$tableau_reor[$i][3]$tableau_reor[$i][4]\n";
}



my $color;
my $width;
my $width2;
my $dx;
my $dy;
my $dz;
my $distance;
my $start_x;
my $start_y;
my $start_z;
my $end_x;
my $end_y;
my $end_z;
for($i=$nb_atomes;$i>=1;$i--)
{
#print $i."\n";

	#On commence par afficher l'atome
	#print $out "\n%Coordonnées atome\n";
	print $out "\n\t\\coordinate ($tableau_reor[$i][3]$i) at ($tableau_reor[$i][1],$tableau_reor[$i][2],$tableau_reor[$i][0]);\n";

	$color=$tableau_atomes{$tableau_reor[$i][3]}{"color"};
	$width=$tableau_atomes{$tableau_reor[$i][3]}{"radius"};
	print $out "\t\\shadedraw [ball color = $color] ($tableau_reor[$i][3]$i) circle ($width);\n";	

	#On cherche ensuite à tracer les liaisons chimiques. on part de l'atome courant vers les atomes de z plus élevés 
	for($j=$i-1;$j>=1;$j--)
	{
#print "j".$j."\n";
	$width2=$tableau_atomes{$tableau_reor[$j][3]}{"radius"};
	$dx=$tableau_reor[$i][0]-$tableau_reor[$j][0];
	$dy=$tableau_reor[$i][1]-$tableau_reor[$j][1];
	$dz=$tableau_reor[$i][2]-$tableau_reor[$j][2];
	$distance=sqrt($dx**2+$dy**2+$dz**2);
	#Si la distance est inférieure à 1,9 Angstrom, on trace un lien entre les atomes
		if($distance<=1.9 && $tableau_reor[$i][3] ne "H" && $tableau_reor[$j][3] ne "H")
		{
			#on calcule le point théorique de sortie de la liaison pour avoir une bonne perspective
			$start_x=sprintf("%.4f",$tableau_reor[$i][0]-$dx/$distance*$width);
			$start_y=sprintf("%.4f",$tableau_reor[$i][1]-$dy/$distance*$width);
			$start_z=sprintf("%.4f",$tableau_reor[$i][2]-$dz/$distance*$width);
			print $out "\t\\coordinate ($tableau_reor[$i][3]$i-$tableau_reor[$j][3]$j-start) at ($start_y,$start_z,$start_x);";	
			#on calcule le point d'entrée théorique de la liaison
			$end_x=sprintf("%.4f",$tableau_reor[$j][0]+$dx/$distance*$width2);
			$end_y=sprintf("%.4f",$tableau_reor[$j][1]+$dy/$distance*$width2);
			$end_z=sprintf("%.4f",$tableau_reor[$j][2]+$dz/$distance*$width2);
			print $out "\\coordinate ($tableau_reor[$i][3]$i-$tableau_reor[$j][3]$j-end) at ($end_y,$end_z,$end_x);\n";
			print $out "\t\\draw [liaison] ($tableau_reor[$i][3]$i-$tableau_reor[$j][3]$j-start) -- ($tableau_reor[$i][3]$i-$tableau_reor[$j][3]$j-end);\n";
		}
		if($distance<=2.4 && $tableau_reor[$i][3] eq "Se" && $tableau_reor[$j][3] eq "Se")
		{
			#on calcule le point théorique de sortie de la liaison pour avoir une bonne perspective
			$start_x=sprintf("%.4f",$tableau_reor[$i][0]-$dx/$distance*$width);
			$start_y=sprintf("%.4f",$tableau_reor[$i][1]-$dy/$distance*$width);
			$start_z=sprintf("%.4f",$tableau_reor[$i][2]-$dz/$distance*$width);
			print $out "\t\\coordinate ($tableau_reor[$i][3]$i-$tableau_reor[$j][3]$j-start) at ($start_y,$start_z,$start_x);";	
			#on calcule le point d'entrée théorique de la liaison
			$end_x=sprintf("%.4f",$tableau_reor[$j][0]+$dx/$distance*$width2);
			$end_y=sprintf("%.4f",$tableau_reor[$j][1]+$dy/$distance*$width2);
			$end_z=sprintf("%.4f",$tableau_reor[$j][2]+$dz/$distance*$width2);
			print $out "\\coordinate ($tableau_reor[$i][3]$i-$tableau_reor[$j][3]$j-end) at ($end_y,$end_z,$end_x);\n";
			print $out "\t\\draw [liaison] ($tableau_reor[$i][3]$i-$tableau_reor[$j][3]$j-start) -- ($tableau_reor[$i][3]$i-$tableau_reor[$j][3]$j-end);\n";
		}
		if($distance<=1.2 && ($tableau_reor[$i][3] eq "H" || $tableau_reor[$j][3] eq "H"))
		{
			#on calcule le point théorique de sortie de la liaison pour avoir une bonne perspective
			$start_x=sprintf("%.4f",$tableau_reor[$i][0]-$dx/$distance*$width);
			$start_y=sprintf("%.4f",$tableau_reor[$i][1]-$dy/$distance*$width);
			$start_z=sprintf("%.4f",$tableau_reor[$i][2]-$dz/$distance*$width);
			print $out "\t\\coordinate ($tableau_reor[$i][3]$i-$tableau_reor[$j][3]$j-start) at ($start_y,$start_z,$start_x);";	
			#on calcule le point d'entrée théorique de la liaison
			$end_x=sprintf("%.4f",$tableau_reor[$j][0]+$dx/$distance*$width2);
			$end_y=sprintf("%.4f",$tableau_reor[$j][1]+$dy/$distance*$width2);
			$end_z=sprintf("%.4f",$tableau_reor[$j][2]+$dz/$distance*$width2);
			print $out "\\coordinate ($tableau_reor[$i][3]$i-$tableau_reor[$j][3]$j-end) at ($end_y,$end_z,$end_x);\n";
			print $out "\t\\draw [liaison] ($tableau_reor[$i][3]$i-$tableau_reor[$j][3]$j-start) -- ($tableau_reor[$i][3]$i-$tableau_reor[$j][3]$j-end);\n";
		}
		if($distance<=2.5 && ($tableau_reor[$i][3] eq ("Fe"||"Cr") || $tableau_reor[$j][3] eq ("Fe"||"Cr")))
		{
			#on calcule le point théorique de sortie de la liaison pour avoir une bonne perspective
			$start_x=sprintf("%.4f",$tableau_reor[$i][0]-$dx/$distance*$width);
			$start_y=sprintf("%.4f",$tableau_reor[$i][1]-$dy/$distance*$width);
			$start_z=sprintf("%.4f",$tableau_reor[$i][2]-$dz/$distance*$width);
			print $out "\t\\coordinate ($tableau_reor[$i][3]$i-$tableau_reor[$j][3]$j-start) at ($start_y,$start_z,$start_x);";	
			#on calcule le point d'entrée théorique de la liaison
			$end_x=sprintf("%.4f",$tableau_reor[$j][0]+$dx/$distance*$width2);
			$end_y=sprintf("%.4f",$tableau_reor[$j][1]+$dy/$distance*$width2);
			$end_z=sprintf("%.4f",$tableau_reor[$j][2]+$dz/$distance*$width2);
			print $out "\\coordinate ($tableau_reor[$i][3]$i-$tableau_reor[$j][3]$j-end) at ($end_y,$end_z,$end_x);\n";
			print $out "\t\\draw [liaison2] ($tableau_reor[$i][3]$i-$tableau_reor[$j][3]$j-start) -- ($tableau_reor[$i][3]$i-$tableau_reor[$j][3]$j-end);\n";
		}

	}
}

print $out "\\end{scope}\n\\end{tikzpicture}\n%\\end{figure}\n\\end{document}";
